/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#ifndef __AUX
#define __AUX

#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include "defs.h"
#include "messages.h"

field *load_stage(char *, field *);
field *choosing_level(int);
char *which_stage_to_load(char *);
void unload_stage(field *);

char **allocate_matrix(int, int);

void read_string(char *, int);

char *int_to_string (int);

int all_boxes_placed (field *);
int is_right_place(field *, int, int);

void finish_game(void);

int empty_list(list *);
node *store_list(list *, int);
void destroy_list(list *);
list *build_list(void);

void print_list(list *);
void remove_last_node(list *);

#endif
