/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#ifndef __DEFS
#define __DEFS

#define RIGHT_PLACE         '0'
#define FREE_SPACE          ' '
#define BOX                 '#'
#define PLAYER              '*'

#define GAP		            51 //at least n ( n = max(sizeof(*.bmp)) )

#define UP                  0
#define RIGHT               1
#define DOWN                2
#define LEFT                3

#define PIXEL_JUMP_AT_ANI   1
#define TIME_TO_REST_AT_ANI 2

int step;

int SELECTED_SW; //SCREEN_W selected by player
int SELECTED_SH; //SCREEN_H selected by player


//#define IMAGE_PATH image/

BITMAP *box;
BITMAP *box_at_place;
BITMAP **player;
BITMAP *right_place;
BITMAP *wall;
BITMAP *back;
BITMAP *bkg;
MIDI   *ost;

/*----------------------------------------------------------------------------*/

struct dot
{
	int x;
	int y;
};

typedef struct dot position;

/*----------------------------------------------------------------------------*/

struct node
{
    int direction;
    struct node *next;
};

typedef struct node node;

/*----------------------------------------------------------------------------*/

typedef struct {
    node *first, *last;
    int size;
} list;

/*----------------------------------------------------------------------------*/

struct field
{
	int lines, columns;
	char **field;
	position player;
	position *right_places;
	int number_of_right_places;
	int level;
    list *list_of_steps;
};

typedef struct field field;

/*----------------------------------------------------------------------------*/
#endif
