/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

#include "si.h"

int already_setup = 0;

int main (void)
{

	field *stage;
	int new_game;
	char *level;
	char password[11];

    if(already_setup == 0)
    {
    	setup_game();
        already_setup = 1;
    }

    step = 1;
	stage = NULL;

	new_game = welcome();


	if (new_game == 1)
	{
	acquire_screen();
		clear_to_color(screen, makecol(0,0,0));

		textout_ex (screen, font, "Loading stage 1...",
					5, 5, makecol(255, 0, 0), makecol(0, 0, 0));

		release_screen();
        stage = malloc(sizeof(field));
		stage = load_stage("0", stage);
	}
    //password
	else
	{
		acquire_screen();
		clear_to_color(screen, makecol(0,0,0));

		textout_ex(screen, font, "Type password",
				   3, 1, makecol(255, 0, 0), makecol(0, 0, 0));

		release_screen();
		read_string(password, 10);

		level = which_stage_to_load (password);

		if ( level != NULL )
		{
			acquire_screen();
			clear_to_color(screen, makecol(0,0,0));

			textprintf_ex(screen, font, 5, 5, makecol(255, 255, 255), -1,
						  "Loading stage %s...", level);

			release_screen();
			stage = choosing_level(atoi(level));
		}
		else
		{
			acquire_screen();

			textprintf_ex(screen, font, 5, 15, makecol(255, 255, 255), -1,
				      "Password \"%s\" does not match.", password);

			release_screen();
            rest(1000);
            main();
		}

		rest(1000);
	}


	//starting game
	if (stage != NULL)
    {
        stage->list_of_steps = build_list();
		play(stage);
    }

	finish_game();
	return (1);
}
END_OF_MAIN();
