/*
      ___           ___           ___                        ___     
     /  /\         /__/\         /  /\          ___         /  /\    
    /  /:/_        \  \:\       /  /::\        /__/\       /  /:/_   
   /  /:/ /\        \__\:\     /  /:/\:\       \  \:\     /  /:/ /\  
  /  /:/ /::\   ___ /  /::\   /  /:/  \:\       \  \:\   /  /:/ /:/_ 
 /__/:/ /:/\:\ /__/\  /:/\:\ /__/:/ \__\:\  ___  \__\:\ /__/:/ /:/ /\
 \  \:\/:/~/:/ \  \:\/:/__\/ \  \:\ /  /:/ /__/\ |  |:| \  \:\/:/ /:/
  \  \::/ /:/   \  \::/       \  \:\  /:/  \  \:\|  |:|  \  \::/ /:/ 
   \__\/ /:/     \  \:\        \  \:\/:/    \  \:\__|:|   \  \:\/:/  
     /__/:/       \  \:\        \  \::/      \__\::::/     \  \::/   
     \__\/         \__\/         \__\/           ~~~~       \__\/    
                        
			    ___           ___   
			   /  /\         /  /\  
			  /  /:/        /  /:/  
			 /__/::\       /  /:/   
			 \__\/\:\__   /  /::\   
			    \  \:\/\ /__/:/\:\  
			     \__\::/ \__\/  \:\ 
			     /__/:/       \  \:\
			     \__\/         \__\/

*/

/*
	Take care with print_game function and loading player's beggining position
at load_stage function because allegro's functions work just like cartesian
plane, and matrix works totally different.

cartesian_plane:    (x,y - x means collumns and y means lines)
matrix:             (i,j - i means lines and j means collumns)

	Otherwise you'll get a flipped matrix and keys go wrong.
	Thanks.
*/

/*TODO
FUNCTIONALS
run audio
change the way matrix is loaded in order to fix cartesian plane and matrix
make possible return one step

IMPROVEMENTS
fix some variables that are accessed to many times just like "stage->player.x"
change some names of BITMAP *
*/

#ifndef __SI
#define __SI

#include <allegro.h>
#include "defs.h"
#include "messages.h"
#include "aux_functions.h"
#include "setup.h"
#include "play.h"

#endif
